import { a9 as __rest, aa as HeroContent, ab as ImageOnDevice, ac as ImageWithSlide, ad as ImageWithSlideList } from './index.esm2.js';
import { jsx } from 'react/jsx-runtime';
import { Component } from 'react';
import PropTypes from 'prop-types';
import gsap from 'gsap';
import { ScrollTrigger } from 'gsap/ScrollTrigger';
import '@qubejs/core';
import 'react-dom';
import 'react-google-recaptcha';
import 'react-router-dom';

gsap.registerPlugin(ScrollTrigger);
const compMap = {
  HeroContent,
  ImageOnDevice,
  ImageWithSlide,
  ImageWithSlideList
};
const presetAnimation = {
  sliderWithScrub: {}
};
class MagicHeroContentDefault extends Component {
  constructor(props) {
    super(props);
    this.state = {};
  }
  getTarget(target) {
    const {
      name
    } = this.props;
    if (target && target.rule) {
      return CSSRulePlugin.getRule(target.rule);
    }
    return (name ? '.' + name + ' ' : '') + target;
  }
  applyTweens(tweens, timeline) {
    this.allTweens = [];
    tweens.forEach(tween => {
      const {
          target,
          start
        } = tween,
        restTween = __rest(tween, ["target", "start"]);
      if (restTween.from && restTween.to) {
        this.allTweens.push((timeline || gsap).fromTo(this.getTarget(target), restTween.from, restTween.to, start));
      } else if (restTween.from) {
        this.allTweens.push((timeline || gsap).from(this.getTarget(target), restTween.from, start));
      } else if (restTween.to) {
        this.allTweens.push((timeline || gsap).to(this.getTarget(target), restTween.to, start));
      }
    });
  }
  getTimeline() {
    let {
      timeline
    } = this.props;
    const {
      tweens,
      animation
    } = this.props;
    if (presetAnimation[animation]) {
      timeline = presetAnimation[animation];
    }
    return {
      tweens,
      timeline
    };
  }
  componentDidMount() {
    const {
      tweens,
      timeline
    } = this.getTimeline();
    const _a = JSON.parse(JSON.stringify(timeline || {})),
      {
        tweens: tlTweens = []
      } = _a,
      restTimeline = __rest(_a, ["tweens"]);
    if (timeline) {
      this.tlObj = gsap.timeline(restTimeline);
      this.trigger = restTimeline.trigger;
      tlTweens && this.applyTweens(tlTweens, this.tlObj);
    }
    tweens && this.applyTweens(tweens);
    setTimeout(() => {
      (restTimeline === null || restTimeline === void 0 ? void 0 : restTimeline.scrollTrigger) && ScrollTrigger.refresh();
    }, 500);
  }
  componentWillUnmount() {
    this.killAll();
  }
  killAll() {
    var _a, _b, _c;
    (_a = this.allTweens) === null || _a === void 0 ? void 0 : _a.forEach(tween => {
      tween && tween.kill(true);
    });
    ((_b = this.tlObj) === null || _b === void 0 ? void 0 : _b.scrollTrigger) && this.tlObj.scrollTrigger.kill(true);
    (_c = this.tlObj) === null || _c === void 0 ? void 0 : _c.pause(0).kill(true);
    this.tlObj = null;
  }
  render() {
    const _a = this.props,
      {
        name,
        content = {},
        className = ''
      } = _a,
      restProps = __rest(_a, ["name", "content", "className"]);
    const {
        component
      } = content,
      restContent = __rest(content, ["component"]);
    const CmpToRender = compMap[component] || compMap.HeroContent;
    return jsx("div", {
      className: `sq-magic-hero-content-pencil ${className} ${name}`,
      children: jsx(CmpToRender, Object.assign({}, restProps, restContent))
    });
  }
}
MagicHeroContentDefault.propTypes = {
  items: PropTypes.array
};

export { MagicHeroContentDefault as default };
